  Shader "Custom/Isolines" {
    Properties {
      _MainTex ("Texture", 2D) = "white" {}
      _BumpMap ("Bumpmap", 2D) = "bump" {}
      _IsolinesColor ("IsolinesColor", Color) = (1,0,0,1)
      _heightInterval ("_heightInterval",float) = 1
      _lineWidth ("_lineWidth",float) = 0.1
      _Up ("_Up (x, y, z)", vector) = (0,1,0)
    }
    SubShader {
      Tags { "RenderType" = "Opaque" }
      //Cull Off
      CGPROGRAM
      #pragma surface surf Lambert vertex:vert
      	  fixed4 _IsolinesColor;
          float _heightInterval;
      	  float _lineWidth;
      	  fixed3 _Up;
 
      
      struct Input {
          float3 worldPos;
          float2 uv_MainTex;
          float2 uv_BumpMap;
          float a11;
      };
      sampler2D _MainTex;
      sampler2D _BumpMap;
      
              
      void vert (inout appdata_full v, out Input o) {
          UNITY_INITIALIZE_OUTPUT(Input,o);
          o.a11 = length(cross(v.normal, _Up));
      } 
      
      
      
      void surf (Input IN, inout SurfaceOutput o) {

          //float a1 = frac(IN.worldPos.y/_heightInterval) - 1 +_lineWidth/_heightInterval;
          float a1 = frac(IN.worldPos.y/_heightInterval) - 1 +_lineWidth* IN.a11/_heightInterval;
          if(a1>0){
          	  o.Albedo = tex2D (_MainTex, IN.uv_MainTex).rgb + _IsolinesColor.rgb;
          	  
          }else{
           	  o.Albedo = tex2D (_MainTex, IN.uv_MainTex).rgb;
         }
          o.Normal = UnpackNormal (tex2D (_BumpMap, IN.uv_BumpMap));
      }
      ENDCG
    } 
    Fallback "Diffuse"
  }